# li'l Judd version 2

"Oh boy, here we go again" ~ me

A Discord Bot for Splatoon Teams

[![Latest Release](https://gitlab.com/moonleay/liljudd/-/badges/release.svg)](https://gitlab.com/moonleay/liljudd/-/releases)
[![pipeline status](https://gitlab.com/moonleay/liljudd/badges/master/pipeline.svg)](https://gitlab.com/moonleay/liljudd/-/commits/master)
[![License](https://img.shields.io/badge/license-GPL--3.0-brightgreen)](https://gitlab.com/moonleay/liljudd/-/blob/master/LICENSE)

## Contributors

[![Developer](https://img.shields.io/badge/moonleay-Developer-red)](https://gitlab.com/moonleay)

## Known issues

- There is a bug with the TimePlanning feature. This bug makes the bot not remove the user properly, the result looks
  like [this](https://cdn.discordapp.com/attachments/1015606848797290566/1110671293436661812/image.png)

## Commands & Features

- Commands
    - version -- Show the versions of the bot and the most important dependencies
    - feature -- Manage bot features
- Features
    - Time Planner -- Make the bot send messages and reactions into a selected channel in order to make planning easier

## Maybe upcoming features

- Match Planner (Send Notifications some time before a match starts)
- Game Tracker (Save the results of the last matches)
- Replay Saver (Maybe; will save the replay code to a database)

## How to self-host (using the Docker container)

1. Pull the container
2. Map /data/ to a folder on disk
3. Run the Bot once
4. Follow step 4 - 7 of "How to self-host (using the JAR)"

## How to self-host (using the JAR)

1. Download the latest release from the Package Registry ("Packages and registries" > "Package Registry")
    1. It should be called something like this: "lilJudd-X.X.X-xxxxxxxx-prod.jar" (replace "X.X.X" with the latest
       version and xxxxxxxx" with the commit its based on.)
    2. If you want to run an early version, which may be (very) unsable, you can run a development version. Just use an
       entry ending in "-dev.jar"
2. Place it anywhere you want.
3. Run the following command:
   > java -jar lilJudd-X.X.X-xxxxxxxx-prod.jar
4. The bot should start and create a config file named "credentials.nils" in a folder called "data"
5. Open it and put in your credentials.
    1. token: your Discord bot token
    2. dbDomain: the domain and port of your postgresql database (e.g.: 192.168.178.1:5432)
    3. dbName: the name of your database
    4. dbUser: the username of the database
    5. dbPassword: the password to your user
6. Rerun the command
   > java -jar lilJudd-X.X.X-xxxxxxxx-prod.jar
7. The bot should now be up and running.

## How to set up workspace

Install IntellJ and import the project from git.
Done.

## Docker commands 4 me

- docker build -t limiteddev/liljudd:x.x.x .
- docker push limiteddev/liljudd:x.x.x
